=== modified file '.bzrignore'
--- .bzrignore	2010-03-23 15:44:51 +0000
+++ .bzrignore	2010-04-14 06:34:41 +0000
@@ -7,5 +7,4 @@
 *.log
 _trial_temp
 loggerhead-memprofile
-docs/_build/doctrees
-docs/_build/html
+./docs/_build/

=== modified file 'NEWS'
--- NEWS	2010-02-26 04:38:23 +0000
+++ NEWS	2010-04-13 23:35:01 +0000
@@ -4,6 +4,9 @@
 dev [future]
 ------------
 
+    - Documentation added in the docs directory. README simplified
+      accordingly. (Tres Seaver).
+
     - Show svn/git/hg revision ids in loggerhead revision view.
       (Jelmer Vernooij)
 
@@ -15,8 +18,12 @@
     - Repository.get_revision_inventory() was removed in bzr 2.2; use
       Repository.get_inventory() instead. (Matt Nordhoff, #528194)
 
+    - Ignore readonly+ prefix when checking if Loggerhead is serving a
+      local location. (Reported by Tres Seaver.) (Matt Nordhoff)
+
+
 1.17 [20Aug2009]
----------------
+----------------
 
     - Add bug links in revision informations (Alexandre Garnier, #314052)
 
@@ -120,7 +127,7 @@
 
     - Fix a file descriptor leak (Matt Nordhoff, #370845)
 
-    - Use transport API internally, so it is possible to specify a remote 
+    - Use transport API internally, so it is possible to specify a remote
       URL to serve-branches. (Jelmer Vernooij, #371787)
 
     - Fix internal server errors when using start-loggerhead. (Matt
@@ -169,7 +176,7 @@
 
 
 1.10 [22Dec2008]
----------------
+----------------
 
     - Add startup deamon script for Linux (Marius Kruger)
 

=== modified file 'README'
--- README	2009-11-27 18:06:53 +0000
+++ README	2010-04-13 23:35:01 +0000
@@ -1,127 +1,28 @@
-LOGGERHEAD
+Loggerhead
 ==========
 
-[ Version 1.17 for Bazaar 1.17 ]
-
-Loggerhead is a web viewer for Bazaar branches.  It can be used to
-navigate a branch history, annotate files, perform searches... all the
-usual things.
-
-
-GETTING STARTED
----------------
-
-Loggerhead depends on:
-
-1) SimpleTAL for templating.
-   On Ubuntu, `sudo apt-get install python-simpletal`
-   or download from http://www.owlfish.com/software/simpleTAL/download.html
-2) simplejson for producing JSON data.
-   On Ubuntu, `sudo apt-get install python-simplejson`
-   or use `easy_install simplejson`.
-3) Paste for the server. (You need version 1.2 or newer of Paste.)
-   On Ubuntu, `sudo apt-get install python-paste`
-   or use `easy_install Paste`
-4) Paste Deploy  (optional, needed when proxying through Apache)
-   On Ubuntu, `sudo apt-get install python-pastedeploy`
-   or use `easy_install PasteDeploy`
-5) flup (optional, needed to use FastCGI, SCGI or AJP)
-   On Ubuntu, `sudo apt-get install python-flup`
-   or use `easy_install flup`
-
-Then simply run the 'serve-branches' with the branch you want to
-serve on the command line:
-
-    ./serve-branches ~/path/to/branch
-
-The script listens on port 8080 so head to http://localhost:8080/ in
-your browser to see the branch.  You can also pass a directory that
-contains branches to the script, and it will serve a very simple
-directory listing at other pages.
-
-You may update the Bazaar branches being viewed at any time.
-Loggerhead will notice and refresh, and Bazaar uses its own branch
-locking to prevent corruption.
-
-To run loggerhead as a linux daemon:
-1) Copy loggerheadd to /etc/init.d
-2) Edit the file to configure where your loggerhead is installed, and which
-   serve-branches options you would like.
-3) Register the service
-   cd /etc/init.d
-   a) on upstart based systems like Ubuntu run: 
-      update-rc.d loggerheadd defaults
-   b) on Sysvinit based systems like Centos or SuSE run:
-      chkconfig --add loggerheadd
-
-
-LOGGERHEAD AS A BAZAAR PLUGIN
------------------------------
-
-This branch contains experimental support for using Loggerhead as a Bazaar
-plugin.  To use it, place the top-level Loggerhead directory (the one
-containing this file) at ``~/.bazaar/plugins/loggerhead``.
-
-
-USING A CONFIG FILE
--------------------
-
-To hide branches from being displayed, add to ``~/.bazaar/locations.conf``,
-under the branch's section:
-
-    [/path/to/branch]
-    http_serve = False
-
-
-More configuration options to come soon.
-
-
-SERVING LOGGERHEAD FROM BEHIND APACHE
--------------------------------------
-
-If you want to view Bazaar branches from your existing Apache
-installation, you'll need to configure Apache to proxy certain
-requests to Loggerhead.  Adding lines like this to you Apache
-configuration is one way to do this::
-
-    <Location "/branches/">
-        ProxyPass http://127.0.0.1:8080/branches/
-        ProxyPassReverse http://127.0.0.1:8080/branches/
-    </Location>
-
-If Paste Deploy is installed, the 'serve-branches' script can be
-run behind a proxy at the root of a site, but if you're running it at
-some path into the site, you'll need to specify is using '--prefix=/some_path'.
-
-
-SEARCH
-------
-
-Search is currently supported by using the bzr-search plugin (available
-at: ``https://launchpad.net/bzr-search``
-You need to have the plugin installed and each branch indexed to allow
-searching on branches.
-
-
-SUPPORT
--------
-
-Loggerhead is loosely based on bazaar-webserve, which was loosely
-based on hgweb.  Discussion should take place on the bazaar-dev
-mailing list at bazaar@lists.canonical.com.  You can join the list at
-<https://lists.ubuntu.com/mailman/listinfo/bazaar>.  You don't need to
-subscribe to post, but your first post will be held briefly for manual
-moderation.
-
-Bugs are tracked on Launchpad; start at:
-
-    https://bugs.launchpad.net/loggerhead
-
-
-HACKING
--------
-
-To run loggerhead tests, you will need the package python-nose,
-and run in the loggerhead directory:
-
-    nosetests
+Overview
+--------
+
+Loggerhead is a web viewer for Bazaar branches. Its lets users do
+stuff like:
+
+* navigate through branch history
+* view the files in a given revision
+* annotate files (i.e. find out the origin of each line of a file)
+* perform searches.
+
+
+Documentation
+-------------
+
+See docs/index.rst for installation instructions and basic
+documentation.
+
+
+Licensing
+---------
+
+This software is (C) Copyright Canonical Limited 2006-10 under the
+GPL Version 2 or later. Please see the file COPYING.txt for the
+licence details.

=== added file 'README.mod_wsgi'
--- README.mod_wsgi	1970-01-01 00:00:00 +0000
+++ README.mod_wsgi	2010-04-18 14:41:23 +0000
@@ -0,0 +1,36 @@
+To deploy loggerhead via mod_wsgi, you need to add configuration for apache and
+for bazaar.  Example config files are in the loggerhead doc directory as
+loggerhead.conf and bazaar.conf.  You can copy them into place and use them as
+a starting point if you want.
+
+1) Edit /etc/loggerhead/bazaar.conf.  You need to set http_root_dir to the filesystem
+   path that you will find your bzr branches under.  Note that normal
+   directories under that path will also be visible in loggerhead.
+
+2) Install mod_wsgi.  On Fedora-derived distros::
+     su -c yum install mod_wsgi
+
+   On Debian-derived distros::
+     sudo apt-get install libapache2-mod-wsgi
+
+3) Install the apache conf file::
+     # cp /usr/share/doc/loggerhead-*/loggerhead.conf /etc/httpd/conf.d/
+
+4) Edit /etc/httpd/conf.d/loggerhead.conf to point to the url you desire to
+   serve loggerhead on.  This should match with the setting for
+   http_user_prefix in bazaar.conf
+
+5) Restart apache and you should be able to start browsing
+
+.. note:: If you have SELinux enabled on your system you may need to allow
+   apache to execute files in temporary directories.  You will get a
+   MemoryError traceback from python if this is the case.  This is because of
+   the way that python ctypes interacts with libffi.  To rectify this, you may
+   have to do several things, such as mounting tmpdirs so programs can be
+   executed on them and setting this SELinux boolean::
+
+       setsebool httpd_tmp_exec on
+
+    This bug has information about how we might solve this issue permanently
+    and links to bugs which diagnose the root cause.
+    https://bugzilla.redhat.com/show_bug.cgi?id=582009

=== modified file '__init__.py'
--- __init__.py	2009-10-17 06:35:33 +0000
+++ __init__.py	2010-04-13 23:35:01 +0000
@@ -26,7 +26,7 @@
 
 """Loggerhead web viewer for Bazaar branches.
 
-This provides a new option "--http" to the "bzr serve" command, that 
+This provides a new option "--http" to the "bzr serve" command, that
 starts a web server to browse the contents of a branch.
 """
 
@@ -38,7 +38,7 @@
 
     require_any_api(bzrlib, [
         (1, 13, 0), (1, 15, 0), (1, 16, 0), (1, 17, 0), (1, 18, 0),
-        (2, 0, 0), (2, 1, 0)])
+        (2, 0, 0), (2, 1, 0), (2, 2, 0)])
 
     # NB: Normally plugins should lazily load almost everything, but this
     # seems reasonable to have in-line here: bzrlib.commands and options are

=== added file 'apache-loggerhead.conf'
--- apache-loggerhead.conf	1970-01-01 00:00:00 +0000
+++ apache-loggerhead.conf	2010-04-18 14:41:23 +0000
@@ -0,0 +1,19 @@
+### If you receive MemoryError tracebacks setting up loggerhead under mod_wsgi,
+### read /usr/share/doc/loggerhead*/README.mod_wsgi for help
+Alias /bzr/static /usr/share/loggerhead/static
+RewriteEngine On
+RewriteRule ^/bzr$ /bzr/ [R]
+
+WSGIDaemonProcess loggerhead user=apache group=apache maximum-requests=1000 display-name=loggerhead processes=4 threads=1
+WSGISocketPrefix run/wsgi
+WSGIRestrictStdout On
+WSGIRestrictSignal Off
+
+WSGIScriptAlias /bzr /usr/bin/loggerhead.wsgi
+
+<Location /bzr>
+    WSGIProcessGroup loggerhead
+    Order deny,allow
+    Allow from all
+</Location>
+

=== added file 'bazaar.conf'
--- bazaar.conf	1970-01-01 00:00:00 +0000
+++ bazaar.conf	2010-04-18 14:41:23 +0000
@@ -0,0 +1,9 @@
+# directory to serve bzr branches from
+# Non-bzr directories under this path will also be visible in loggerhead
+#http_root_dir = '/var/www/bzr'
+
+# The url prefix for the bzr branches.
+http_user_prefix = '/bzr'
+
+# Directory to put cache files in
+http_sql_dir = '/var/cache/loggerhead'

=== modified file 'docs/index.rst'
--- docs/index.rst	2010-03-25 10:28:03 +0000
+++ docs/index.rst	2010-04-13 08:46:25 +0000
@@ -1,7 +1,7 @@
 Loggerhead:  A web viewer for ``bzr`` branches
 ==============================================
 
-Loggerhead is a web viewer for projects in bazaar. It can be used to navigate 
+Loggerhead is a web viewer for projects in Bazaar. It can be used to navigate 
 a branch history, annotate files, view patches, perform searches, etc.
 Loggerhead is heavily based on `bazaar-webserve
 <https://launchpad.net/bzr-webserve>`_, which was, in turn, loosely
@@ -106,7 +106,7 @@
 
 This branch contains experimental support for using Loggerhead as a Bazaar
 plugin.  To use it, place the top-level Loggerhead directory (the one
-containing this file) at ``~/.bazaar/plugins/loggerhead``.  E.g.:
+containing COPYING.txt) at ``~/.bazaar/plugins/loggerhead``.  E.g.:
 
 .. code-block:: sh
 
@@ -134,7 +134,7 @@
 
 If you want to view Bazaar branches from your existing Apache
 installation, you'll need to configure Apache to proxy certain
-requests to Loggerhead.  Adding lines like this to you Apache
+requests to Loggerhead.  Adding lines like this to your Apache
 configuration is one way to do this:
 
 .. code-block:: apache
@@ -146,7 +146,7 @@
 
 If Paste Deploy is installed, the :command:`serve-branches` script can be
 run behind a proxy at the root of a site, but if you're running it at
-some path into the site, you'll need to specify is using
+some path into the site, you'll need to specify it using
 ``--prefix=/some_path``.
 
 
@@ -179,7 +179,7 @@
 subscribe to post, but your first post will be held briefly for manual
 moderation.
 
-Bugs are tracked on Launchpad; start at:
+Bugs, support questions and merge proposals are tracked on Launchpad, e.g:
 
     https://bugs.launchpad.net/loggerhead
 

=== modified file 'docs/serve-branches.rst'
--- docs/serve-branches.rst	2010-03-25 10:25:13 +0000
+++ docs/serve-branches.rst	2010-03-25 10:32:47 +0000
@@ -79,8 +79,9 @@
     Allow writing to the Bazaar server.
     
     Setting this option keeps Loggerhead from adding a 'readonly+' prefix
-    to the base URL of is to make visible the display of instructions for
-    checking out the 'public_branch' URL for the branch being browsed.
+    to the base URL of the branch.  The only effect of suppressing this prefix
+    is to make visible the display of instructions for checking out the
+    'public_branch' URL for the branch being browsed.
 
 .. cmdoption:: -h, --help
 

=== modified file 'docs/start-loggerhead.rst'
--- docs/start-loggerhead.rst	2010-03-25 10:25:13 +0000
+++ docs/start-loggerhead.rst	2010-03-25 10:39:30 +0000
@@ -11,7 +11,7 @@
 
 .. code-block:: sh
 
-   start-loggerhead [OPTIONS]
+    start-loggerhead [OPTIONS]
 
 Options
 -------
@@ -22,7 +22,7 @@
 
 .. cmdoption:: -h, --help
 
-    Show this help message and exit
+    Show this help message and exit.
 
 .. cmdoption:: --foreground
 
@@ -30,17 +30,17 @@
 
 .. cmdoption:: -C, --check
 
-    Only start if not already running (useful for cron jobs)
+    Only start if not already running (useful for cron jobs).
 
 .. cmdoption:: -p, --pidfile=PIDFILE
 
-    override pid file location
+    Override pid file location.
 
 .. cmdoption:: -c, --config-file=CONFIGFILE
 
-   Override configuration file location [XXX default is
-   :file:`/etc/loggerhead.conf`]
+    Override configuration file location (the default is
+    :file:`/etc/loggerhead.conf`).
 
 .. cmdoption:: --log-folder=LOG_FOLDER
 
-    The directory [XXX in which] to place log files
+    The directory in which to place log files.

=== modified file 'loggerhead.conf.example'
--- loggerhead.conf.example	2008-07-22 00:40:03 +0000
+++ loggerhead.conf.example	2009-10-17 09:28:42 +0000
@@ -23,7 +23,7 @@
 
     # name of this project
     name = 'bazaar'
-    
+
     # for the top browsing page, you can include a description, in raw HTML.
     #description = 'Bazaar is a <i>revision control system</i>.'
 
@@ -63,13 +63,13 @@
 [paramiko]
     name = 'paramiko'
     cachepath = '/Users/robey/code/paramiko/.bzr/loggerhead-files'
-    
+
     # if an auto_publish_folder is given, any bazaar branches discovered in
     # that folder will be published.  using each branch's 'branch.conf' to
     # provide optional descriptions and public urls is a nice way to avoid
     # having to do much configuration here.
     auto_publish_folder = '/Users/robey/code/paramiko'
-    
+
     # if all of the branches under an auto_publish_folder are exported to
     # the same (base) public url, you can specify that url prefix here, and
     # each discovered branch's public url will be generated.

=== added file 'loggerhead.wsgi'
--- loggerhead.wsgi	1970-01-01 00:00:00 +0000
+++ loggerhead.wsgi	2010-04-18 14:41:23 +0000
@@ -0,0 +1,36 @@
+#!/usr/bin/python -tt
+
+import sys
+import os
+import pwd
+sys.path.insert(0, os.path.dirname(__file__))
+
+from paste.httpexceptions import HTTPExceptionHandler
+from loggerhead.apps.transport import BranchesFromTransportRoot
+from loggerhead.apps.error import ErrorHandlerApp
+from loggerhead.config import LoggerheadConfig
+from bzrlib import config as bzrconfig
+from paste.deploy.config import PrefixMiddleware
+from bzrlib.plugin import load_plugins
+
+class NotConfiguredError(Exception):
+    pass
+
+
+load_plugins()
+config = LoggerheadConfig()
+prefix = config.get_option('user_prefix') or ''
+# Note we could use LoggerheadConfig here if it didn't fail when a
+# config option is not also a commandline option
+root_dir = bzrconfig.GlobalConfig().get_user_option('http_root_dir')
+if not root_dir:
+    raise NotConfiguredError('You must have a ~/.bazaar/bazaar.conf file for'
+            ' %(user)s with http_root_dir set to the base directory you want'
+            ' to serve bazaar repositories from' %
+            {'user': pwd.getpwuid(os.geteuid()).pw_name})
+prefix = prefix.encode('utf-8', 'ignore')
+root_dir = root_dir.encode('utf-8', 'ignore')
+app = BranchesFromTransportRoot(root_dir, config)
+app = PrefixMiddleware(app, prefix=prefix)
+app = HTTPExceptionHandler(app)
+application = ErrorHandlerApp(app)

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2009-10-17 06:35:33 +0000
+++ loggerhead/apps/branch.py	2010-03-25 16:19:24 +0000
@@ -21,6 +21,7 @@
 import sys
 
 import bzrlib.branch
+import bzrlib.errors
 import bzrlib.lru_cache
 
 from paste import request
@@ -145,9 +146,10 @@
             else:
                 # Loggerhead only supports serving .bzr/ on local branches, so
                 # we shouldn't suggest something that won't work.
-                if self.branch.base.startswith('file://'):
+                try:
+                    util.local_path_from_url(self.branch.base)
                     self.served_url = self.url([])
-                else:
+                except bzrlib.errors.InvalidURL:
                     self.served_url = None
         path = request.path_info_pop(environ)
         if not path:

=== modified file 'loggerhead/apps/transport.py'
--- loggerhead/apps/transport.py	2009-11-26 03:20:53 +0000
+++ loggerhead/apps/transport.py	2010-03-25 16:19:24 +0000
@@ -28,6 +28,7 @@
 from paste import httpexceptions
 from paste import urlparser
 
+from loggerhead import util
 from loggerhead.apps.branch import BranchWSGIApp
 from loggerhead.apps import favicon_app, robots_app, static_app
 from loggerhead.controllers.directory_ui import DirectoryUI
@@ -93,11 +94,8 @@
             # TODO: Use something here that uses the transport API
             # rather than relying on the local filesystem API.
             base = self.transport.base
-            readonly_prefix = 'readonly+'
-            if base.startswith(readonly_prefix):
-                base = base[len(readonly_prefix):]
             try:
-                path = urlutils.local_path_from_url(base)
+                path = util.local_path_from_url(base)
             except errors.InvalidURL:
                 raise httpexceptions.HTTPNotFound()
             else:

=== modified file 'loggerhead/config.py'
--- loggerhead/config.py	2009-11-23 22:45:46 +0000
+++ loggerhead/config.py	2010-04-13 23:35:01 +0000
@@ -87,7 +87,7 @@
         self.SQL_DIR = sql_dir
 
     def get_option(self, option):
-        """Get the value for the config option, either 
+        """Get the value for the config option, either
         from ~/.bazaar/bazaar.conf or from the command line.
         All loggerhead-specific settings start with 'http_'
         """

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2009-06-25 03:35:43 +0000
+++ loggerhead/controllers/changelog_ui.py	2009-10-17 06:55:25 +0000
@@ -106,7 +106,7 @@
             'navigation': navigation,
             'filter_file_id': filter_file_id,
             'start_revid': start_revid,
-            'viewing_from': (orig_start_revid is not None) and 
+            'viewing_from': (orig_start_revid is not None) and
                             (orig_start_revid != history.last_revid),
             'query': query,
             'search_failed': search_failed,

=== modified file 'loggerhead/controllers/diff_ui.py'
--- loggerhead/controllers/diff_ui.py	2009-10-17 08:59:33 +0000
+++ loggerhead/controllers/diff_ui.py	2010-04-08 01:08:33 +0000
@@ -72,7 +72,7 @@
         filename = '%s_%s.diff' % (revno1, revno2)
         headers = [
             ('Content-Type', 'application/octet-stream'),
-            ('Content-Length', len(content)),
+            ('Content-Length', str(len(content))),
             ('Content-Disposition', 'attachment; filename=%s' % (filename,)),
             ]
         start_response('200 OK', headers)

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2009-10-17 09:21:55 +0000
+++ loggerhead/controllers/download_ui.py	2010-04-08 01:08:33 +0000
@@ -61,7 +61,7 @@
         encoded_filename = urllib.quote(filename.encode('utf-8'))
         headers = [
             ('Content-Type', mime_type),
-            ('Content-Length', len(content)),
+            ('Content-Length', str(len(content))),
             ('Content-Disposition',
              "attachment; filename*=utf-8''%s" % (encoded_filename,)),
             ]

=== modified file 'loggerhead/static/css/annotate.css'
--- loggerhead/static/css/annotate.css	2009-03-01 20:57:52 +0000
+++ loggerhead/static/css/annotate.css	2009-04-30 10:39:05 +0000
@@ -4,7 +4,7 @@
 	border:1px solid #d2d2d2;
 }
 .annoLine, .annoRev, .annoComm, .annoCont {
-	border:none;	
+	border:none;
 }
 .annoLine {
 	width:37px;

=== modified file 'loggerhead/static/css/global.css'
--- loggerhead/static/css/global.css	2009-06-11 21:16:27 +0000
+++ loggerhead/static/css/global.css	2009-10-17 06:55:25 +0000
@@ -180,7 +180,7 @@
 }
 #loggerheadCont p.expand, #loggerheadCont p.expand a, #loggerheadCont p.expand a:link, #loggerheadCont p.expand a:visited, #loggerheadCont p.expand a:hover {
 	color:#000;
-	text-decoration:none;	
+	text-decoration:none;
 }
 #loggerheadCont p img {
 	vertical-align:middle;
@@ -192,7 +192,7 @@
 }
 .revnolink a, .revnolink a:visited, .revnolink a:link, .revnolink a:hover {
 	color:#CC6600;
-	text-decoration:none;		
+	text-decoration:none;
 }
 
 /*Log Table*/
@@ -214,7 +214,7 @@
 }
 .blueRow0, .blueRow1 {
 	background:#eef6fa;
-	font:normal 14px/normal sans-serif;	
+	font:normal 14px/normal sans-serif;
 	padding:0px;
 	margin:0px;
 }
@@ -228,7 +228,7 @@
 	border:1px solid #d2d2d2;
 }
 .expandcell, .expcell {
-	width:28px;	
+	width:28px;
 }
 .summarycell, .authorcell, .tagscell, .datecell, .timedate{
   padding: 4px 8px;

=== modified file 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/annotate.pt	2009-03-06 09:57:54 +0000
+++ loggerhead/templates/annotate.pt	2009-04-30 10:39:05 +0000
@@ -58,7 +58,7 @@
             <td class="annoContTit">Contents</td>
           </tr>
 
-          <tr tal:repeat="line contents" 
+          <tr tal:repeat="line contents"
               tal:attributes="class string:blueRow${line/parity}">
             <td class="annoLine"><a tal:attributes="id string:L${line/lineno}; href string:#L${line/lineno}" tal:content="line/lineno">1</a></td>
             <td class="annoRev">

=== modified file 'loggerhead/templates/browse.pt'
--- loggerhead/templates/browse.pt	2009-05-13 13:14:04 +0000
+++ loggerhead/templates/browse.pt	2009-10-17 06:55:25 +0000
@@ -28,7 +28,7 @@
                   <img tal:attributes="src python:branch.static_url('/static/images/ico_branch.gif')" alt="Branch" />
                 </td>
                 <td class="autcell">
-                    <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)" 
+                    <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)"
                        tal:content="view/friendly_name" />
                 </td>
                 <td class="autcell"

=== modified file 'loggerhead/templates/directory.pt'
--- loggerhead/templates/directory.pt	2009-11-27 00:14:35 +0000
+++ loggerhead/templates/directory.pt	2010-04-13 23:35:01 +0000
@@ -19,7 +19,7 @@
             <th class="datecell">Latest Rev</th>
             <th class="datecell">Last Changed</th>
           </tr>
-          
+
           <tr class="blueRow0" tal:condition="python:name != '/'">
             <td class="icocell">
                 <a href="../"><img tal:attributes="src python:static_url('/static/images/ico_folder_up.gif')" /></a>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2009-07-15 22:02:09 +0000
+++ loggerhead/templates/inventory.pt	2009-10-17 06:55:25 +0000
@@ -70,7 +70,7 @@
                                              title string:Go to ${file/filename}" />
                     </a>
 
-                 <a tal:attributes="href python:url(['/files', revno_url, file.absolutepath])" 
+                 <a tal:attributes="href python:url(['/files', revno_url, file.absolutepath])"
                                         tal:content="file/filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
@@ -93,7 +93,7 @@
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_file_flecha.gif')" alt="Symlink" />
                     </a>
 
-                 <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])" 
+                 <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])"
                                         tal:content="file/filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
@@ -118,7 +118,7 @@
                                              title string:Annotate ${file/filename}"
                              tal:condition="python:file.executable is False" />
                         <!-- Show a different icon id the file executable -->
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif'); 
+                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif');
                                              title string:Annotate ${file/filename}"
                              tal:condition="python:file.executable is True" alt="File" />
                     </a>

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2009-11-26 03:44:40 +0000
+++ loggerhead/util.py	2010-03-25 16:19:24 +0000
@@ -36,6 +36,8 @@
 except ImportError:
     from elementtree import ElementTree as ET
 
+from bzrlib import urlutils
+
 from simpletal.simpleTALUtils import HTMLStructureCleaner
 
 log = logging.getLogger("loggerhead.controllers")
@@ -324,6 +326,14 @@
     return out
 
 
+def local_path_from_url(url):
+    """Convert Bazaar URL to local path, ignoring readonly+ prefix"""
+    readonly_prefix = 'readonly+'
+    if url.startswith(readonly_prefix):
+        url = url[len(readonly_prefix):]
+    return urlutils.local_path_from_url(url)
+
+
 def fill_in_navigation(navigation):
     """
     given a navigation block (used by the template for the page header), fill

=== modified file 'loggerheadd'
--- loggerheadd	2008-11-24 20:26:26 +0000
+++ loggerheadd	2009-04-30 10:39:05 +0000
@@ -16,9 +16,9 @@
 
 LHUSER=loggerhead
 
-if [ `whoami` = "$LHUSER" ]; then                                                                                   
+if [ `whoami` = "$LHUSER" ]; then
     SUDO=""
-else                                                                                                                
+else
     SUDO="sudo -H -u $LHUSER"
 fi
 

